'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _Button = require('material-ui/Button');

var _Button2 = _interopRequireDefault(_Button);

var _styles = require('material-ui/styles');

var _translate = require('../../i18n/translate');

var _translate2 = _interopRequireDefault(_translate);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Responsive = require('../layout/Responsive');

var _Responsive2 = _interopRequireDefault(_Responsive);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
    button: {
        display: 'inline-flex',
        alignItems: 'center'
    },
    label: {
        paddingLeft: '0.5em'
    }
};

var Button = function Button(_ref) {
    var children = _ref.children,
        className = _ref.className,
        _ref$classes = _ref.classes,
        classes = _ref$classes === undefined ? {} : _ref$classes,
        _ref$color = _ref.color,
        color = _ref$color === undefined ? 'primary' : _ref$color,
        label = _ref.label,
        translate = _ref.translate,
        rest = (0, _objectWithoutProperties3.default)(_ref, ['children', 'className', 'classes', 'color', 'label', 'translate']);
    return _react2.default.createElement(
        _Button2.default,
        (0, _extends3.default)({
            className: (0, _classnames2.default)(classes.button, className),
            color: color
        }, rest),
        children,
        _react2.default.createElement(_Responsive2.default, {
            small: _react2.default.createElement('span', null),
            medium: _react2.default.createElement(
                'span',
                { className: classes.label },
                label && translate(label)
            )
        })
    );
};

Button.propTypes = {
    children: _propTypes2.default.node.isRequired,
    className: _propTypes2.default.string,
    classes: _propTypes2.default.object,
    color: _propTypes2.default.string,
    label: _propTypes2.default.string,
    translate: _propTypes2.default.func.isRequired
};

var enhance = (0, _compose2.default)((0, _styles.withStyles)(styles), _translate2.default);

exports.default = enhance(Button);
module.exports = exports['default'];